package neutrino.multitext.adapters.styled;

import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.JScrollPane;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.filechooser.*;

import neutrino.multitext.TextEditorAdapter;
import neutrino.text.components.styled.RTFComponent;
import neutrino.text.TextEditor;

/**
 * @author Oleh Radvanskyj
 * @version 1.0
 */
public class RTFEditorAdapter extends TextEditorAdapter {

	private RTFComponent textComponent = null;
	private TextEditor textEditor = null;
	private JScrollPane component = null;
	
	public RTFEditorAdapter() {
		super();
		textComponent = new RTFComponent();
		textComponent.setUndoable(true);
		MutableAttributeSet attributeSet = new SimpleAttributeSet();
		StyleConstants.setForeground(attributeSet, Color.BLACK);
		StyleConstants.setBackground(attributeSet, Color.WHITE);
		textComponent.setCharacterAttributes(attributeSet, false);
		textEditor = new TextEditor(textComponent);
		textEditor.setAcceptAllFileFilterUsed(false);
		textEditor.setFileFilter(new FileNameExtensionFilter("Rich Text Format (RTF)", "rtf"));
		component = new JScrollPane();
		component.setViewportView(textComponent);
		setLayout(new BorderLayout());
		add(component, BorderLayout.CENTER);
	}

	@Override
	public TextEditor getTextEditor() {
		return textEditor;
	}

}